package com.ejie.ab61.model.configuracionEventos;

import java.util.Date;

import org.springframework.context.i18n.LocaleContextHolder;

import com.ejie.ab61.comun.Constantes;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * ConfigEventos  
 * 
 *  
 */

public class ConfigEventos implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idConfigEventos;
	private String tipoEvento;
	private String plateaType;
	private String plateaSubtype;
	private Integer configuracion;
	private String descripcionCastellano;
	private String descripcionEuskera;
	private Integer instanceId;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Integer numeroConfiguraciones;

	/**
	 * Method 'ConfigEventos'.
	 */
	public ConfigEventos() {
	}

	/**
	 * Method 'ConfigEventos'.
	 * 
	 * @param idConfigEventos
	 *            Integer
	 */
	public ConfigEventos(Integer idConfigEventos) {
		this.idConfigEventos = idConfigEventos;
	}

	/**
	 * Method 'ConfigEventos'.
	 * 
	 * @param idConfigEventos
	 *            Integer
	 * @param tipoEvento
	 *            String
	 * @param plateaType
	 *            String
	 * @param plateaSubtype
	 *            String
	 * @param configuracion
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public ConfigEventos(Integer idConfigEventos, String tipoEvento, String plateaType, String plateaSubtype,
			Integer configuracion, Date fechaRegistro, String usuarioRegistro, String descripcionCastellano,
			String descripcionEuskera, Integer instanceId) {

		this.idConfigEventos = idConfigEventos;
		this.tipoEvento = tipoEvento;
		this.plateaType = plateaType;
		this.plateaSubtype = plateaSubtype;
		this.configuracion = configuracion;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.descripcionCastellano = descripcionCastellano;
		this.descripcionEuskera = descripcionEuskera;
		this.instanceId = instanceId;
	}

	/**
	 * Method 'getIdConfigEventos'.
	 *
	 * @return Integer
	 */

	public Integer getIdConfigEventos() {
		return this.idConfigEventos;
	}

	/**
	 * Method 'setIdConfigEventos'.
	 *
	 * @param idConfigEventos
	 *            Integer
	 * @return
	 */

	public void setIdConfigEventos(Integer idConfigEventos) {
		this.idConfigEventos = idConfigEventos;
	}

	/**
	 * Method 'getTipoEvento'.
	 *
	 * @return String
	 */

	public String getTipoEvento() {
		return this.tipoEvento;
	}

	/**
	 * Method 'setTipoEvento'.
	 *
	 * @param tipoEvento
	 *            String
	 * @return
	 */

	public void setTipoEvento(String tipoEvento) {
		this.tipoEvento = tipoEvento;
	}

	/**
	 * Method 'getPlateaType'.
	 *
	 * @return String
	 */

	public String getPlateaType() {
		return this.plateaType;
	}

	/**
	 * Method 'setPlateaType'.
	 *
	 * @param plateaType
	 *            String
	 * @return
	 */

	public void setPlateaType(String plateaType) {
		this.plateaType = plateaType;
	}

	/**
	 * Method 'getPlateaSubtype'.
	 *
	 * @return String
	 */

	public String getPlateaSubtype() {
		return this.plateaSubtype;
	}

	/**
	 * Method 'setPlateaSubtype'.
	 *
	 * @param plateaSubtype
	 *            String
	 * @return
	 */

	public void setPlateaSubtype(String plateaSubtype) {
		this.plateaSubtype = plateaSubtype;
	}

	/**
	 * Method 'getConfiguracion'.
	 *
	 * @return Integer
	 */

	public Integer getConfiguracion() {
		return this.configuracion;
	}

	/**
	 * Method 'setConfiguracion'.
	 *
	 * @param configuracion
	 *            Integer
	 * @return
	 */

	public void setConfiguracion(Integer configuracion) {
		this.configuracion = configuracion;
	}

	/**
	 * @return the descripcionCastellano
	 */
	public String getDescripcionCastellano() {
		return descripcionCastellano;
	}

	/**
	 * @param descripcionCastellano
	 *            the descripcionCastellano to set
	 */
	public void setDescripcionCastellano(String descripcionCastellano) {
		this.descripcionCastellano = descripcionCastellano;
	}

	/**
	 * @return the descripcionEuskera
	 */
	public String getDescripcionEuskera() {
		return descripcionEuskera;
	}

	/**
	 * @param descripcionEuskera
	 *            the descripcionEuskera to set
	 */
	public void setDescripcionEuskera(String descripcionEuskera) {
		this.descripcionEuskera = descripcionEuskera;
	}

	public String getDescripcion() {
		if (LocaleContextHolder.getLocale().getLanguage().equalsIgnoreCase(Constantes.Language.CASTELLANO)) {
			return this.descripcionCastellano;
		} else {
			return this.descripcionEuskera;
		}
	}

	/**
	 * @return the instanceId
	 */
	public Integer getInstanceId() {
		return this.instanceId;
	}

	/**
	 * @param instanceId
	 *            the instanceId to set
	 */
	public void setInstanceId(Integer instanceId) {
		this.instanceId = instanceId;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'
	 * 
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'
	 * 
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'
	 * 
	 * @return String
	 */
	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'
	 * 
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */
	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * @return the numeroConfiguraciones
	 */
	public Integer getNumeroConfiguraciones() {
		return numeroConfiguraciones;
	}

	/**
	 * @param numeroConfiguraciones
	 *            the numeroConfiguraciones to set
	 */
	public void setNumeroConfiguraciones(Integer numeroConfiguraciones) {
		this.numeroConfiguraciones = numeroConfiguraciones;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idConfigEventos: ").append(this.idConfigEventos).append(" ]");
		result.append(", [ tipoEvento: ").append(this.tipoEvento).append(" ]");
		result.append(", [ plateaType: ").append(this.plateaType).append(" ]");
		result.append(", [ plateaSubtype: ").append(this.plateaSubtype).append(" ]");
		result.append(", [ configuracion: ").append(this.configuracion).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
